Bug 517273 (CVE-2009-2195) - CVE-2009-2195 WebKit: buffer overflow in floating point numbers parsing
Summary: CVE-2009-2195 WebKit: buffer overflow in floating point numbers parsing
Keywords:
Status: CLOSED UPSTREAM
Alias: CVE-2009-2195
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
urgent
urgent
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL: http://web.nvd.nist.gov/view/vuln/det...
Whiteboard: impact=critical,source=cve,reported=2...
Depends On: 580662
Blocks:
TreeView+ depends on / blocked
 
Reported: 2009-08-13 10:42 UTC by Tomas Hoger
Modified: 2019-06-08 12:48 UTC (History)
10 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2010-09-22 14:56:20 UTC


Attachments (Terms of Use)

Description Tomas Hoger 2009-08-13 10:42:33 UTC
Common Vulnerabilities and Exposures assigned an identifier CVE-2009-2195 to the following vulnerability:

Buffer overflow in WebKit in Apple Safari before 4.0.3 allows remote
attackers to execute arbitrary code or cause a denial of service
(application crash) via crafted floating-point numbers.

References:
http://support.apple.com/kb/HT3733
http://lists.apple.com/archives/security-announce/2009/Aug/msg00002.html

Upstream fix with test cases:
http://trac.webkit.org/changeset/45696

Likely to affect webkit versions shipped in Fedora (WebKit, webkitgtk, QT).

Comment 1 Tomas Hoger 2009-08-13 10:44:32 UTC
Another two webkit CVEs are covered in HT3733, but all relevant changes are in mac or win specific directories, so do not seem to apply:

CVE-2009-2199
  http://trac.webkit.org/changeset/45254

CVE-2009-2200
  http://trac.webkit.org/changeset/44905
  http://trac.webkit.org/changeset/44909

Comment 2 Tomas Hoger 2009-08-13 10:58:52 UTC
Note: looks like upstream commit 45696 is included in webkitgtk 1.1.11 and later.

Comment 3 Kevin Kofler 2009-08-13 14:30:28 UTC
Any idea whether this also affects KHTML? There's also a version of dtoa.cpp in there, but AFAIK it's somewhat different and might not be affected.

Qt 4.5.2's QtWebKit appears to be vulnerable. I do NOT see the changeset with the fix in the JavaScriptCore changelog.

Comment 4 Tomas Hoger 2009-08-14 08:21:09 UTC
We've tested couple of konqueror/KHTML versions with test cases from the above commit, none of the versions misbehaved.

Comment 5 Ngo Than 2009-08-14 11:38:42 UTC
i cannot reproduce this issue with kdelibs (3.x in rhelX, 4.x in fedora) and qt-4.5.2. The code is a bit different.

Comment 6 Vincent Danen 2009-12-02 21:27:54 UTC
Does anything here affect Fedora 12?  If so, which versions?  IU see webkitkde and webkitgtk, and we have QT as well right?  Fedora 12 has QT version 4.5.3 so I am to understand that means it is not vulnerable?  What about the others?

Comment 7 Tomas Hoger 2009-12-03 06:57:43 UTC
webkitkde should not contain another webkit copy, but rather only provide KDE "wrapper" / bindings around qtwebkit in qt.

Based on comment #2, webkitgtk 1.1.11 and later should have a fix, i.e. F12 should be fine, F11 still has 1.1.10.

Having a quick look into qt 4.5 tree git version of the file, it seems quite different, so may not have that commit that introduced this regression.  But it seems Kevin had a closer look on qtwebkit version, given the comment #3.

Comment 8 Kevin Kofler 2009-12-03 13:15:02 UTC
Well, I didn't find the fix in 4.5.2, but I don't know if it was vulnerable, and I haven't looked at 4.5.3 at all so far.

Comment 9 Vincent Danen 2010-04-08 18:15:41 UTC
Following up on this, Fedora 11 still has webkitgtk-1.1.10 so would still be vulnerable.

Do we know if qt-4.5.3 corrects this?  Current Fedora has 4.6.2, so may not be vulnerable.

Comment 17 Vincent Danen 2010-04-23 15:44:04 UTC
The upstream fix is included in QtWebKit 4.6.2 (qt-everywhere-opensource-src-4.6.2/src/3rdparty/webkit/JavaScriptCore/wtf/dtoa.cpp), so Fedora 11+ is ok.  Only webkitgtk on Fedora 11 would still be vulnerable to this.

Comment 18 Rakesh Pandit 2010-05-29 06:30:21 UTC
I think we need to close this as F11 is already EOL ?

Comment 19 Kevin Kofler 2010-05-29 06:32:49 UTC
No, it's not. The F11 EOL is on June 25.

Comment 20 Lukáš Tinkl 2010-09-22 13:10:56 UTC
Can we close this now? :)

Comment 21 Vincent Danen 2010-09-22 14:56:20 UTC
Yes, we can.  Thanks.


Note You need to log in before you can comment on or make changes to this bug.